#/usr/bin/perl
# samcount22a.pl
# env bam=$pt.bam hdr=1 nr=100000 perl samcount22a.pl

$bam=$ENV{bam};  $NR= $ENV{nr}||0; 
$NOTFL= $ENV{notfl} || 0x200; ## old 0x104 == SAMFLAG_nomap | SAMFLAG_2ndary ; change default to 0x200
$DOHDR= ($ENV{nohdr})?0:1;

( $n_in, $n_readid, $n_nomap, $n_supp, $n_dupl, $n_prime,
   $sum_readlen, $n_align, $n_mismatch, $n_insert, $n_delete, $n_softclip,
   $sum_supplen, $sum_duplen, $sum_unmap,)= (0) x 19;
   
unless(-s $bam){ die "usage: env bam=my.bam nr=Nrows samcount22a.pl"; }
open(B,"samtools view -F $NOTFL $bam | ") or die "samtools view $bam";
while(<B>){
  my($rdid,$fl,$cr,$cb,$cx,$cig)=@samx= split;
  $n_in++; $rdlen=length($samx[9]);
  $rty=0; $addc=0;
     if($fl & 0x100){ $rty=2; $addc=0; $n_dupl++; }
  elsif($fl & 0x800){ $rty=4; $addc=1; $n_supp++; }
  elsif($fl & 0x04) { $rty=0; $addc=0; $n_nomap++; $n_readid++; $sum_readlen += $rdlen; }
  elsif($fl < 0x100){ $rty=1; $addc=1; $n_prime++; $n_readid++; $sum_readlen += $rdlen; }
  $alen=0;
  while($cig =~ m/(\d+)(\D)/g) { 
    my($bi,$bt)=($1,$2);
    if($bt eq 'M' or $bt eq 'X' or $bt eq '=') { $n_align += $bi if($addc); $alen+=$bi; }
    elsif($bt eq 'I') { $n_insert += $bi if($addc); $alen+=$bi; }
    elsif($bt eq 'D') { $n_delete += $bi if($addc); }
    elsif($bt eq 'S') { $n_softclip += $bi if($addc); }
    #elsif($bt eq 'N') { $n_intron+=$bi if($addc); }
    else { $n_other+=$bi if($addc); }
  }
  if($rty == 4){ $sum_supplen+=$alen; }
  elsif($rty == 2){ $sum_duplen+=$alen; }
  elsif($rty == 0){ $sum_unmap+=$rdlen; }
  if(m/NM:i:(\d+)/){ $n_mismatch += $1 if($addc); }
  last if($NR and $n_in >= $NR);
} close(B);

# out2put();
out3put();

sub out2put {
  print join("\t", qw( n_in n_reads n_nomap n_supp n_dupl
      n_bases n_align n_mism n_insrt n_dele n_softc suplen duplen nolen bam) )."\n" if($DOHDR); 
  print join("\t", $n_in, $n_readid, $n_nomap, $n_supp, $n_dupl,
     $sum_readlen, $n_align, $n_mismatch, $n_insert, $n_delete, $n_softclip, $sum_supplen, $sum_duplen, $sum_unmap, $bam)."\n"; 
}

sub MB{ my @r; for my $r (@_){ my $f=($r>50000000)?".0f":($r<1000000)?".2f":".1f"; push @r,sprintf"%$f",$r/1000000; } return @r; }
sub pctof { my($n,$d,$pd)=@_; $pd||=0; return ($d<1)?0:sprintf "%.${pd}f%%",100*$n/$d; }
sub bout { 
  my($nbc,$nb,@pb)=@_; 
  return($nb,@pb) unless($nb>0);
  my @po=map{ my $p=100*$_/$nb; my $pd=($p<5)?2:1; sprintf "%.${pd}f%%",$p; } @pb; 
  my $db=$nbc - $nb; my $nbs="";
  if(abs($db)/$nb > 0.01) { ($nbs)= join",",MB($nb,$nbc); } else { ($nbs)= MB($nb); }
  return($nbs."Mb",@po); 
}

sub out3put {
  # recalcs: n_supalign = sum_supplen, n_sc_unplaced = n_softclip - sum_supplen
  # sum_bases = n_align + n_insert + n_sc_unplaced + sum_unmap
  my $b_unclip = $n_softclip - $sum_supplen;
  my $sum_bases = $n_align + $n_insert + $b_unclip + $sum_unmap;
  
  @nreads= ($n_in, $n_readid, $n_nomap, $n_supp, $n_dupl); #? $n_prime == n_readid - n_nomap
  @lreads= qw(n_in n_reads n_unmap n_supp n_dupl);
  @nbases= ($sum_readlen, $n_align, $sum_supplen, $n_insert, $b_unclip, $sum_unmap);
  @lbases= qw(b_reads b_align b_supaln b_unins  b_unclip b_unmap);
  @nother= ($n_mismatch, $n_delete, $sum_duplen);
  @lother= qw(c_mismat  c_delete c_dupaln);
  
  @preads= @nreads; 
  $preads[2]= pctof($n_nomap,$n_readid,2); @preads[3,4]=("-","-");
  @pbases= bout( $sum_bases, @nbases); 
  @pother= @nother; 
  $pother[0]= pctof($n_mismatch,$n_align,1);
  $pother[1]= pctof($n_delete,$n_align,1);
  $pother[2]= pctof($sum_duplen,$n_align,0);
  
  print join("\t", @lreads, @lbases, @lother, 'bamfile' )."\n" if($DOHDR); 
  print join("\t", @nreads, @nbases, @nother, $bam)."\n";
  print join("\t", @preads, @pbases, @pother, $bam)."\n";
}

=item out3put parts pct table

n_in    n_reads n_unmap b_reads b_align b_supal b_unins b_uncli b_unmap c_misma c_dele  c_dupal rdtype  bamfile
aweed20gnodes/
5000000 1976284 3.45%   296.4Mb 94.0%   0.16%   0.10%   2.41%   3.45%   1.3%    0.2%    153%    sr_Ilnp at22vcan2d_chrs_ERR8666067_ab_mim.bam
100000  29620   0.42%   670.5Mb 97.3%   9.4%    1.57%   0.76%   0.39%   5.0%    1.8%    84%     lr_Pbhi at22vcan2d_chrs_ERR8666125_mim.bam
100000  76754   0.34%   945.0Mb 99.4%   0.70%   0.12%   0.22%   0.30%   0.2%    0.0%    21%     lr_Pbhi at22vcan2d_chrs_SRR16841688_mim.bam
100000  77759   0.00%   974.0Mb 99.8%   0.27%   0.12%   0.04%   0.00%   0.2%    0.0%    26%     lr_Pbhi at22vcan2d_chrs_SRR16841688_wim.bam
100000  66534   3.72%   1840Mb  97.3%   4.82%   2.23%   0.11%   0.32%   9.7%    4.1%    9%      lr_Nano at22vcan2d_chrs_SRR16832054_mim.bam

beet22gnodes/
6000000 1669734 4.08%   250.5Mb 93.3%   0.45%   0.15%   2.46%   4.08%   2.3%    0.2%    255%    sr_Ilnp beet18usda_chr_SRR12705891il_mim.bam
100000  23488   6.35%   247.9Mb 87.5%   17.7%   6.9%    3.67%   1.85%   17.6%   5.4%    110%    lr_Pblo beet18usda_chr_SRR12705892lm_mim.bam
100000  51900   56.21%  544.9Mb 6.9%    3.19%   1.03%   50.0%   42.1%   24.1%   3.6%    36%     lr_Pblo beet15ref1cds_SRR12705892lm_mim.bam
cucum20gnodes/
9000000 362445  3.40%   54.4Mb  93.7%   0.34%   0.05%   2.84%   3.40%   1.3%    0.1%    2071%   sr_Illu cucum19cgi_chr_SRR11300859_2_bwa.bam

corn22gnodes/
4000000 1139507 2.21%   171.4Mb 96.7%   0.02%   0.00%   1.10%   2.19%   0.6%    0.0%    252%    sr_Ilnp zmays20mgd5_chr_ERR3288215_b4_mim.bam
100000  13849   0.12%   201.4Mb 98.1%   21.4%   1.20%   0.55%   0.12%   5.0%    1.9%    231%    lr_Pbhi zmays20mgd5_chr_SRR15447420_b4_mim.bam
100000  21804   0.09%   349.2Mb 96.8%   21.7%   1.22%   1.87%   0.09%   4.9%    1.9%    107%    lr_Pbhi zmays20mgd5_chr_SRR15447420_b4_wim.bam
100000  10644   0.67%   531.8Mb 91.7%   43.9%   5.8%    2.51%   0.02%   23.8%   9.6%    45%     lr_Nano zmays20mgd5_chr_SRR15447406lm_b4_mim.bam

n_in    n_reads n_unmap b_reads b_align b_supal b_unins b_uncli b_unmap c_misma c_dele  c_dupal rdtype  bamfile
chick22gnodes/
100000  75174   0.04%   1125Mb  99.4%   1.35%   0.77%   -0.23%  0.03%   2.0%    0.5%    18%     lr_Pbhi chick19nc_chr_SRR15420786_b2_mim.bam
100000  62786   0.99%   1641Mb  97.3%   6.1%    2.32%   0.17%   0.24%   9.5%    4.1%    10%     lr_Nano chick19nc_chr_SRR15421342_lm_mim.bam

human22gnodes/
5000000 2980624 1.41%   745.2Mb 91.6%   0.12%   0.00%   7.0%    1.41%   0.3%    0.0%    62%     sr_Ilnp human22ttot_chr_SRR3189741_b4_mim.bam
pig20gnodes/
9000000 327178  4.62%   32.7Mb  91.9%   0.23%   0.06%   3.44%   4.62%   1.6%    0.1%    2391%   sr_Illu chrpig11c_SRR4341337_b2_mim.bam

n_in    n_reads n_unmap b_reads b_align b_supal b_unins b_uncli b_unmap c_misma c_dele  c_dupal rdtype  bamfile
drosmel20gnodes/
9000000 266334  2.46%   33.3Mb  96.0%   0.23%   0.02%   1.48%   2.46%   0.2%    0.0%    3204%   sr_Illu drosmel20pi_chr_SRR11460805_b2_mim.bam
9000000 311228  1.79%   38.9Mb  96.2%   0.26%   0.11%   1.92%   1.79%   0.8%    0.2%    2514%   sr_Illu drosmel6ref_chr_SRR11460805_b2_mim.bam
9000000 208333  3.90%   26.0Mb  94.1%   0.19%   0.11%   1.93%   3.90%   0.8%    0.1%    4224%   sr_Illu drosmel20pi_chr_SRR11460802_b2_mim.bam
9000000 269447  3.12%   33.7Mb  94.5%   0.28%   0.11%   2.24%   3.12%   0.9%    0.2%    3003%   sr_Illu drosmel6ref_chr_SRR11460802_b2_mim.bam
9000000 1397844 2.59%   174.7Mb 95.0%   0.31%   0.11%   2.33%   2.59%   0.9%    0.1%    516%    sr_Illu drosmel6ref_chr_SRR11460802_b2_bwa.bam

#----------------------------------------------

=item out3put

env bam=beet18usda_chr_SRR12705892lm_mim.bam hdr=1 nr=100000 perl samcount22a.pl
n_in  n_reads n_unmap n_supp  n_dupl  b_reads b_align   b_supaln  b_uninst  b_unclip  b_unmap c_mismat  c_delete  c_dupaln  bamfile
100000  23488  1491   20965   55547 247882927 217015614 43764115  17182843  9098277   4586193 38192807  11707501  238730518 beet18usda_chr_SRR12705892lm_mim.bam
100000  23488 6.35%   -        -    247.9Mb   87.5%     17.7%     6.9%      3.67%     1.85%   17.6%     5.4%      110%      beet18usda_chr_SRR12705892lm_mim.bam

env bam=beet18usda_chr_SRR12705891il_mim.bam  nr=6000000 perl samcount22a.pl
n_in    n_reads n_unmap n_supp  n_dupl  b_reads   b_align   b_supaln  b_unins b_unclip  b_unmap   c_mismat  c_dele  c_dupaln  bamfile
6000000 1669734 68099    18555  4311711 250460100 233693336 1126673   379309  6172605   10214850  5408369   518836  595520912 beet18usda_chr_SRR12705891il_mim.bam
6000000 1669734 4.08%     -     -       250.5Mb   93.3%     0.45%     0.15%   2.46%     4.08%     2.3%      0.2%    255%      beet18usda_chr_SRR12705891il_mim.bam

env bam=beet15ref1cds_SRR12705892lm_mim.bam  nr=100000 perl samcount22a.pl
n_in  n_reads n_unmap n_supp  n_dupl  b_reads b_align   b_supaln  b_unins b_unclip  b_unmap   c_mismat  c_delete  c_dupaln  bamfile
100000  51900  29175   34531  13569 544867534 37338599  17370157  5633736 272233992 229661207 8999324   1343443   13524552  beet15ref1cds_SRR12705892lm_mim.bam
100000  51900 56.21%    -      -    544.9Mb   6.9%      3.19%     1.03%   50.0%     42.1%     24.1%     3.6%      36%       beet15ref1cds_SRR12705892lm_mim.bam

env bam=bamf/zmays20mgd5_chr_SRR15447420_b4_mim.bam  nr=100000 perl samcount22a.pl
env bam=bamf/zmays20mgd5_chr_SRR15447420_b4_wim.bam  nr=100000 perl samcount22a.pl
env bam=bamf/zmays20mgd5_chr_SRR15447406lm_b4_mim.bam  nr=100000 perl samcount22a.pl
env bam=bamf/zmays20mgd5_chr_ERR3288215_b4_mim.bam  nr=4000000 perl samcount22a.pl

n_in  n_reads n_unmap n_supp  n_dupl  b_reads b_align   b_supaln  b_unins b_unclip  b_unmap   c_mismat  c_delete  c_dupaln  bamfile
100000  13849     17  21455   64696 201404191 197616120 43158488  2425531 1117026   245514    9790337   3748477   457480794 bamf/zmays20mgd5_chr_SRR15447420_b4_mim.bam
100000  13849  0.12%    -     -     201.4Mb   98.1%     21.4%     1.20%   0.55%     0.12%     5.0%      1.9%      231%      bamf/zmays20mgd5_chr_SRR15447420_b4_mim.bam

n_in  n_reads n_unmap n_supp  n_dupl  b_reads b_align   b_supaln  b_unins b_unclip  b_unmap   c_mismat  c_delete  c_dupaln  bamfile
100000  21804   19    28748   49448 349242352 338137505 75838983  4275847 6528010   300990    16721899  6503677   362931603 bamf/zmays20mgd5_chr_SRR15447420_b4_wim.bam
100000  21804 0.09%   -       -     349.2Mb   96.8%     21.7%     1.22%   1.87%     0.09%     4.9%      1.9%      107%      bamf/zmays20mgd5_chr_SRR15447420_b4_wim.bam

n_in  n_reads n_unmap n_supp  n_dupl  b_reads b_align   b_supaln  b_unins   b_unclip  b_unmap c_mismat  c_delete  c_dupaln  bamfile
100000  10644    71   59011   30345 531828706 487731524 233274650 30634990  13370536  91656   116069227 46684573  221671872 bamf/zmays20mgd5_chr_SRR15447406lm_b4_mim.bam
100000  10644 0.67%     -     -     531.8Mb   91.7%     43.9%     5.8%      2.51%     0.02%   23.8%      9.6%     45%       bamf/zmays20mgd5_chr_SRR15447406lm_b4_mim.bam

n_in  n_reads n_unmap n_supp  n_dupl  b_reads   b_align   b_supaln  b_unins b_unclip  b_unmap c_mismat  c_delete  c_dupaln  bamfile
4000000 1139507 25221   494   2859999 171363214 165720689 36878      7383   1877289   3757853 1012109   11036     417683186 bamf/zmays20mgd5_chr_ERR3288215_b4_mim.bam
4000000 1139507 2.21%   -     -       171.4Mb   96.7%     0.02%     0.00%   1.10%     2.19%     0.6%    0.0%      252%      bamf/zmays20mgd5_chr_ERR3288215_b4_mim.bam


#-----------------------------------------------

=item out2put
  .. drop 2nday dups from main counts : ! addc
  env bam=beet18usda_chr_SRR12705892lm_mim.bam hdr=1 nr=100000 notfl=0x200 perl samcount22a.pl  
  
n_in    n_reads n_nom n_supp   n_dupl   n_bases   n_align   n_mism   n_insrt    n_dele   n_softc    suplen    duplen    nolen     bam
6000000 1669734 68099  18555  4311711 250460100 233693336  5408369    379309    518836   7299278   1126673  595520912 10214850  beet18usda_chr_SRR12705891il_mim.bam
100000    23488  1491  20965    55547 247882927 217015614 38192807  17182843  11707501  52862392  43764115  238730518  4586193  beet18usda_chr_SRR12705892lm_mim.bam

n_in   n_reads  n_nom n_supp  n_dupl    n_bases   n_align   n_mism  n_insrt   n_dele   n_softc   suplen   duplen    nolen   bam
400000  112761  3879     61   287178   16930370  16196409   111485      746     1233    187347      4231  41951178  550099  ilnp:zmays20mgd5_chr_ERR3288215_b4_mim
10000    1403      1   2193     6404   20457404  20068861   973203   225806   382994   4457496   4308071  45580101   13312  pbhi:zmays20mgd5_chr_SRR15447420_b4_mim
10000    1770     28   3660     4570   29985903  27493923  6145085  1463350  2508356  11666136  10653115  21532095   15609  nano:zmays20mgd5_chr_SRR15447406lm_b4_mim

=item part calcs
 .. extra cols, move to end: n_mism, n_dele, duplen
 .. maybe change above, or add to: n_reads with any supp, dupl; now count is total supp, dupl rows
 
n_in    n_reads n_nom   n_supp  n_dupl  mb_bases,mbsum  p_align p_insrt p_softc psuplen pnolen  bam
6M      1669734 68099   18555   4311711 250.46,250.46   93.3%   0.2%    2.5%    0.4%    4.1%    beet18usda_chr_SRR12705891il_mim.bam
100000  23488   1491    20965   55547   247.88,247.88   87.5%   6.9%    3.7%    17.7%   1.9%    beet18usda_chr_SRR12705892lm_mim.bam

n_in    n_reads n_nom   n_supp  n_dupl  mb_bases,mbsum  p_align p_insrt p_softc psuplen pnolen  bam
400000  112761  3879    61      287178  16.93,16.93     95.7%   0.0%    1.1%    0.0%    3.2%    ilnp:zmays20mgd5_chr_ERR3288215_b4_mim
10000   1403    1       2193    6404    20.46,20.46     98.1%   1.1%    0.7%    21.1%   0.1%    pbhi:zmays20mgd5_chr_SRR15447420_b4_mim
10000   1770    28      3660    4570    29.99,29.99     91.7%   4.9%    3.4%    35.5%   0.1%    nano:zmays20mgd5_chr_SRR15447406lm_b4_mim

perl -ne 'unless(/^\s*\d+\s+\d/ or /^n_in/){ $x=$xprint; next; }
@v=split; if(/^n_in/){ @v[$IB[0]]="n_bases,nbsum"; print
join("\t",@v[(@IN,@IB,@IX)])."\n"; } else { $nb=@v[@IB[0]];
$nsclip=($v[$IB[3]] - $v[$IB[4]]); $v[$IB[3]]= $nsclip; $nbc=
$v[$IB[1]] + $v[$IB[2]] + $nsclip + $v[$IB[5]];
@vo=bout($nbc,@v[@IB]); print join("\t",@v[@IN],@vo,@v[@IX])."\n"; }
sub bout{my($nbc,$nb,@pb)=@_; @po=map{ sprintf"%.1f%%",100*$_/$nb; }
@pb; $db=$nbc-$nb; $nbs=join",",MB($nb,$nbc); return("$nbs",@po); }
sub MB{ my @r; for my $v (@_) { push @r,sprintf"%.2f",$v/1000000; }
return @r; } sub I0{ return map{ $_ - 1 } @_; } BEGIN{ @IN=I0(1..5);
@IB=I0(6,7,9,11,12,14); @IX=I0(15); @IXA=I0(8,10,13,15); }  ' \
  samcount22a.txt | head -22

  
=item out1put

env bam=beet18usda_chr_SRR12705892lm_mim.bam hdr=1 nr=100000 perl samcount22a.pl
n_in    n_reads n_nomap n_supp  n_dupl  n_bases   n_align    n_mism   n_insrt   n_dele   n_softc    bam
100000  51460   0       48540   0       568081011 507568374  89541841 40529852  27174334 122597780  beet18usda_chr_SRR12705892lm_mim.bam

env bam=beet18usda_chr_SRR12705892lm_mim.bam hdr=1 nr=100000 notfl=0x200 perl samcount22a.pl
n_in    n_reads n_nom n_sup  n_dupl   n_bases n_align   n_mism    n_insrt    n_dele    n_softc   suplen     duplen     nolen   bam
100000    23488  1491 20965   55547 247882927 439673613 79976902  33255362  22780786  499729165 43764115  238730518  4586193  beet18usda_chr_SRR12705892lm_mim.bam
6000000 1669734 68099 18555 4311711 250460100 827463028 29960694   2130529   3035274   58535016  1126673  595520912 10214850  beet18usda_chr_SRR12705891il_mim.bam

60000     31104 17488  20809   8087 325704847 29651246  7072522   4308809  1080672  290916360 10502643    8142289 138203734 beet15ref1cds_SRR12705892lm_mim.bam
2400000 2259435 2035178 1632 138933 338915250 43065553  1666336     52917    82803   11455320    95290   16626346 305276700 beet15ref1cds_SRR12705891il_mim.bam

n_in  n_reads n_nom n_sup n_dup n_bases n_align   n_mism  n_insrt n_dele  n_softc suplen  duplen  nolen     bam
200000  56339 2511  30  143631  8442849  28963900 487868   13225   23897    713268   2404  20971776 344449  zmays20mgd5_chr_ERR3288215_b4_mim.bam sr_Ilnp
200000  55696 1573  29  144275  8376988  28948659 524357   15803   22745    849045   2028  20929847 236495  zmays20mgd5_chr_ERR3288217_mim.bam  sr_Ilnp

  5000  1129   25 1156    2715  9356986  17604088 3654814 773235  1428358 19389369  2538800 9409741  13858    zmays20mgd5_chr_SRR15447406lm_b4_mim.bam lr_Nano
  5000  693     0 1090    3217 10117385  32948926 1429446 310839  452183  25910933  2085636 23257627     0    zmays20mgd5_chr_SRR15447420_b4_mim.bam   lr_Pbhi
200000  27636  33 43177 129187 401623449 1296145491 57512578  12869789  16648557  1057916722  86624940  910155580 472487  zmays20mgd5_chr_SRR15447420_b4_mim.bam


env bam=beet18usda_chr_SRR12705891il_mim.bam hdr=1 nr=1000000 notfl=0x200 perl samcount22a.pl
n_in  n_reads n_nomap n_supp  n_dupl  n_bases n_align n_mism  n_insrt n_dele  n_softc suplen  duplen  nolen bam
1000000 277520  9896  3195  719285  41628000  138617692 4664424 354343  514909  9257498 193183  99771453  1484400 beet18usda_chr_SRR12705891il_mim.bam
6000000 1669734 68099 18555 4311711 250460100 827463028 29960694  2130529 3035274 58535016  1126673 595520912 10214850  beet18usda_chr_SRR12705891il_mim.bam

=item covtab sums

# print " n_in $n_in, n_readid $n_readid, n_nomap $n_nomap, n_supp $n_supp, n_dupl $n_dupl, " 
#          . " sum_bases $sum_readlen, n_align $n_align, " 
#          . " n_mismatch $n_mismatch, n_insert $n_insert, n_delete $n_delete, n_softclip $n_softclip\n"; 
#  sum_align $sum_rdalign, sum_alength $sum_rdalen,


=cut
